<cfcomponent displayname="Screen Size">

<cffunction name="init" access="public" returntype="any" output="no" hint="I initialize and return this component.">
	<cfargument name="DataMgr" type="any" required="yes">
	
	<cfset variables.DataMgr = arguments.DataMgr>
	<cfset variables.datasource = variables.DataMgr.getDatasource()>
	<cfset variables.DataMgr.loadXML(getDbXml(),true,true)>
	
	<cfset variables.build = 2>
	
	<cfreturn this>
</cffunction>

<cffunction name="getBuild" access="package" returntype="numeric" output="no">
	<cfreturn variables.build>
</cffunction>

<cffunction name="logHit" access="public" returntype="void" output="no">
	<cfargument name="width" type="string" required="yes">
	<cfargument name="height" type="string" required="yes">
	<cfargument name="IP" type="string" required="yes">
	<cfargument name="Browser" type="string" required="yes">
	<cfargument name="Page" type="string" required="yes">
	<cfargument name="DomainName" type="string" default="#CGI.SERVER_NAME#">
	
	<cfset arguments.dimensions = "#arguments.width# X #arguments.height#">
	<cfset arguments.UserMark = "#arguments.IP#:  #arguments.Browser#">
	
	<cfif isNumeric(arguments.width) AND isNumeric(arguments.height) AND arguments.width AND arguments.height>
		<cfset variables.DataMgr.insertRecord("rptScreenSizes",arguments)>
	</cfif>
	
</cffunction>

<cffunction name="makePage" access="public" returntype="numeric" output="no">
	<cfargument name="IP" type="string" default="#CGI.REMOTE_HOST#">
	<cfargument name="Browser" type="string" default="#CGI.HTTP_USER_AGENT#">
	<cfargument name="Page" type="string" default="#CGI.SCRIPT_NAME#?#CGI.QUERY_STRING#">
	<cfargument name="DomainName" type="string" default="#CGI.HTTP_HOST#">
	
	<cfset var result = 0>
	
	<cfset arguments.UserMark = "#arguments.IP#:  #arguments.Browser#">
	<cfset arguments.HitDate = now()>
	
	<cfif Right(arguments.Page,1) eq "?">
		<cfset arguments.Page = Left(arguments.Page,Len(arguments.Page)-1)>
	</cfif>
	
	<cfset result = variables.DataMgr.insertRecord("rptScreenSizes",arguments)>
	
	<cfreturn result>
</cffunction>

<cffunction name="setDimensions" access="public" returntype="void" output="no">
	<cfargument name="HitID" type="string" required="yes">
	<cfargument name="width" type="string" required="yes">
	<cfargument name="height" type="string" required="yes">
	
	<cfset arguments.dimensions = "#arguments.width# X #arguments.height#">
	
	<cfif isNumeric(arguments.width) AND isNumeric(arguments.height) AND arguments.width AND arguments.height>
		<cfset variables.DataMgr.updateRecord("rptScreenSizes",arguments)>
	</cfif>
	
</cffunction>

<cffunction name="getHits" access="public" returntype="query" output="no">
	
	<cfset var qData = 0>
	
	<cfquery name="qData" datasource="#variables.datasource#">
	SELECT		dimensions, width, Count(HitID) AS PageViews
	FROM		rptScreenSizes
	GROUP BY	dimensions, width
	ORDER BY	width, dimensions
	</cfquery>
	
	<cfreturn qData>
</cffunction>

<!--- <cffunction name="getUsers" access="public" returntype="query" output="no">
	
	<cfset var qData = 0>
	<cfset var qData2 = 0>
	
	<cfquery name="qData" datasource="#variables.datasource#">
	SELECT		UserMark, dimensions, width, Count(HitID) AS Users
	FROM		rptScreenSizes
	GROUP BY	UserMark, dimensions, width
	ORDER BY	width, dimensions, UserMark
	</cfquery>
	
	<cfreturn qData>
</cffunction> --->

<cffunction name="getDbXml" returntype="string" access="public" output="no" hint="I return the XML for the tables needed for Departments to work.">
	
	<cfset var tableXML = "">
	
	<cfsavecontent variable="tableXML">
	<tables>
		<table name="rptScreenSizes">
			<field ColumnName="HitID" CF_DataType="CF_SQL_INTEGER" PrimaryKey="true" Increment="true" />
			<field ColumnName="IP" CF_DataType="CF_SQL_VARCHAR" Length="80" />
			<field ColumnName="Browser" CF_DataType="CF_SQL_VARCHAR" Length="180" />
			<field ColumnName="DomainName" CF_DataType="CF_SQL_VARCHAR" Length="180" />
			<field ColumnName="Page" CF_DataType="CF_SQL_VARCHAR" Length="180" />
			<field ColumnName="width" CF_DataType="CF_SQL_INTEGER" />
			<field ColumnName="height" CF_DataType="CF_SQL_INTEGER" />
			<field ColumnName="dimensions" CF_DataType="CF_SQL_VARCHAR" Length="60" />
			<field ColumnName="UserMark" CF_DataType="CF_SQL_VARCHAR" Length="250" />
			<field ColumnName="HitDate" CF_DataType="CF_SQL_DATE" />
		</table>
	</tables>
	</cfsavecontent>
	
	<cfreturn tableXML>
</cffunction>

</cfcomponent>